#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 4 "rdql_parser.y"

#include <string.h>

#include "lex.h"
#include "rdfsql/rdql.h"

#define YY_NO_UNPUT
#define YYDEBUG 1
#define YYERROR_VERBOSE

query_t q_data;

void yyerror (char *msg);

#line 21 "rdql_parser.y"
typedef union {
   char         *str;
   pattern_t    *pattern;
   constraint_t *constraint;
   part_t       *part;
   int		 op;
   int		 integer;
   GSList       *list;
} YYSTYPE;
#line 42 "rdql_parser.c"
#define YYERRCODE 256
#define OPEN_PAR 257
#define CLOSE_PAR 258
#define COMMA 259
#define SELECT 260
#define FROM 261
#define WHERE 262
#define USING 263
#define FOR 264
#define AND 265
#define LIMIT 266
#define OFFSET 267
#define URI 268
#define LITERAL 269
#define VARIABLE 270
#define SYMBOL 271
#define INTEGER 272
#define REGEX 273
#define EQ_S 274
#define NE_S 275
#define GT_S 276
#define LT_S 277
#define EQ_N 278
#define NE_N 279
#define GT_N 280
#define LT_N 281
#define LIKE 282
#define EQ_RE 283
#define EOQ 284
const short yylhs[] = {                                        -1,
    0,    2,    2,    1,    1,    1,    9,    9,    9,    3,
    3,    3,   10,   10,   10,   10,   11,   11,   11,   11,
    5,    5,   12,   12,   12,    4,    4,   13,   13,   14,
   14,   14,   14,   14,   14,   14,   14,   14,   14,    6,
    6,    7,    7,    8,    8,
};
const short yylen[] = {                                         2,
   10,    2,    0,    3,    2,    1,    3,    2,    1,    3,
    2,    1,    7,    5,    9,    6,    1,    1,    1,    1,
    2,    0,    5,    4,    3,    3,    0,    3,    3,    1,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    2,
    0,    2,    0,    1,    0,
};
const short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,    5,    0,    0,    4,    0,
    2,    0,    0,    8,    0,    0,    0,    7,   17,   18,
   19,   20,    0,    0,    0,    0,   11,    0,    0,    0,
    0,    0,    0,    0,   10,    0,    0,    0,   30,   31,
   32,   33,   34,   35,   36,   37,   38,   39,    0,   26,
    0,   21,    0,    0,    0,   14,    0,   29,   28,    0,
   40,    0,    0,    0,   16,    0,   42,   44,    1,   13,
    0,    0,   24,    0,   23,   15,
};
const short yydgoto[] = {                                       2,
    4,    8,   16,   25,   34,   54,   63,   69,   11,   17,
   23,   52,   32,   49,
};
const short yysindex[] = {                                   -255,
 -243,    0, -256, -227, -243,    0, -228, -191,    0, -246,
    0, -181, -228,    0, -200, -208, -234,    0,    0,    0,
    0,    0, -239, -195, -185, -181,    0, -200, -200, -204,
 -231, -208, -190, -186,    0, -177, -251, -189,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, -200,    0,
 -179,    0, -184, -180, -200,    0, -175,    0,    0, -182,
    0, -183, -194, -205,    0, -259,    0,    0,    0,    0,
 -200, -190,    0, -167,    0,    0,
};
const short yyrindex[] = {                                      0,
    0,    0, -206, -170,    0,    0,    0,    0,    0, -169,
    0,    0,    0,    0,    0,    6,    1,    0,    0,    0,
    0,    0,    0,    0,    4,    0,    0,    0,    0, -215,
    0,    6,    0,    9,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    2,    0,    0,    0,    0,    0,    0,
    0,    0,   94,    0,    0,    8,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,
};
const short yygindex[] = {                                      0,
   36,    0,   11,   63,    0,    0,    0,    0,   25,    0,
  -13,  -40,    0,    0,
};
#define YYTABLESIZE 293
const short yytable[] = {                                      72,
   12,   43,    5,   22,    1,   27,   56,   25,   41,   29,
   31,   51,   13,    3,   36,   37,   19,   20,   21,   28,
   22,   10,   15,   57,   26,   73,    3,   27,   19,   20,
   21,   75,   22,    7,   14,   59,   35,   18,    6,   10,
    9,   64,   39,   40,   41,   42,   43,   44,   45,   46,
   47,   48,   70,   71,    6,    6,   24,   74,   19,   19,
   19,   19,   19,   19,   19,   19,   19,   19,   20,   21,
   12,   22,   19,   20,   30,   15,   22,   33,   38,   53,
   51,   55,   65,   58,   60,   66,   62,   61,   67,   68,
   76,    3,    9,   45,   50,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   12,    0,   12,   12,   12,   27,   22,
   22,   27,   27,   25,   25,   41,    0,    0,    0,    0,
    0,    0,    0,    0,   12,   43,    0,   22,    0,   27,
    0,   25,   41,
};
const short yycheck[] = {                                     259,
    0,    0,  259,    0,  260,    0,  258,    0,    0,   23,
   24,  271,  259,  270,   28,   29,  268,  269,  270,  259,
  272,  268,  257,   37,  259,   66,  270,   17,  268,  269,
  270,   72,  272,  261,   10,   49,   26,   13,    3,  268,
    5,   55,  274,  275,  276,  277,  278,  279,  280,  281,
  282,  283,  258,  259,  261,  262,  265,   71,  274,  275,
  276,  277,  278,  279,  280,  281,  282,  268,  269,  270,
  262,  272,  268,  269,  270,  257,  272,  263,  283,  266,
  271,  259,  258,  273,  264,  268,  267,  272,  272,  284,
  258,  262,  262,    0,   32,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  263,   -1,  265,  266,  267,  263,  266,
  267,  266,  267,  266,  267,  267,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  284,  284,   -1,  284,   -1,  284,
   -1,  284,  284,
};
#define YYFINAL 2
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 284
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"OPEN_PAR","CLOSE_PAR","COMMA",
"SELECT","FROM","WHERE","USING","FOR","AND","LIMIT","OFFSET","URI","LITERAL",
"VARIABLE","SYMBOL","INTEGER","REGEX","EQ_S","NE_S","GT_S","LT_S","EQ_N","NE_N",
"GT_N","LT_N","LIKE","EQ_RE","EOQ",
};
const char * const yyrule[] = {
"$accept : query",
"query : SELECT var_list from_spec WHERE pattern_list constraint_spec prefix_spec limit_spec offset_spec eoq",
"from_spec : FROM uri_list",
"from_spec :",
"var_list : VARIABLE COMMA var_list",
"var_list : VARIABLE var_list",
"var_list : VARIABLE",
"uri_list : URI COMMA uri_list",
"uri_list : URI uri_list",
"uri_list : URI",
"pattern_list : pattern COMMA pattern_list",
"pattern_list : pattern pattern_list",
"pattern_list : pattern",
"pattern : OPEN_PAR part COMMA part COMMA part CLOSE_PAR",
"pattern : OPEN_PAR part part part CLOSE_PAR",
"pattern : OPEN_PAR part COMMA part COMMA part COMMA part CLOSE_PAR",
"pattern : OPEN_PAR part part part part CLOSE_PAR",
"part : URI",
"part : LITERAL",
"part : VARIABLE",
"part : INTEGER",
"prefix_spec : USING prefix_list",
"prefix_spec :",
"prefix_list : SYMBOL FOR URI COMMA prefix_list",
"prefix_list : SYMBOL FOR URI prefix_list",
"prefix_list : SYMBOL FOR URI",
"constraint_spec : AND constraint constraint_spec",
"constraint_spec :",
"constraint : part operator part",
"constraint : VARIABLE EQ_RE REGEX",
"operator : EQ_S",
"operator : NE_S",
"operator : GT_S",
"operator : LT_S",
"operator : EQ_N",
"operator : NE_N",
"operator : GT_N",
"operator : LT_N",
"operator : LIKE",
"operator : EQ_RE",
"limit_spec : LIMIT INTEGER",
"limit_spec :",
"offset_spec : OFFSET INTEGER",
"offset_spec :",
"eoq : EOQ",
"eoq :",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 49 "rdql_parser.y"
{ q_data.select = yyvsp[-8].list;
		    q_data.from = yyvsp[-7].list;
		    q_data.where = yyvsp[-5].list;
		    q_data.constr = yyvsp[-4].list;
		    q_data.prefixes = yyvsp[-3].list;
		    q_data.limit = yyvsp[-2].integer;
		    q_data.offset = yyvsp[-1].integer;
		  }
break;
case 2:
#line 60 "rdql_parser.y"
{ yyval.list = yyvsp[0].list; }
break;
case 3:
#line 62 "rdql_parser.y"
{ yyval.list = NULL; }
break;
case 4:
#line 66 "rdql_parser.y"
{ yyval.list = g_slist_prepend(yyvsp[0].list, yyvsp[-2].str); }
break;
case 5:
#line 68 "rdql_parser.y"
{ yyval.list = g_slist_prepend(yyvsp[0].list, yyvsp[-1].str); }
break;
case 6:
#line 70 "rdql_parser.y"
{ yyval.list = g_slist_alloc();
		    yyval.list->data = yyvsp[0].str; }
break;
case 7:
#line 75 "rdql_parser.y"
{ yyval.list = g_slist_prepend(yyvsp[0].list, yyvsp[-2].str); }
break;
case 8:
#line 77 "rdql_parser.y"
{ yyval.list = g_slist_prepend(yyvsp[0].list, yyvsp[-1].str); }
break;
case 9:
#line 79 "rdql_parser.y"
{ yyval.list = g_slist_alloc();
		    yyval.list->data = yyvsp[0].str; }
break;
case 10:
#line 84 "rdql_parser.y"
{ yyval.list = g_slist_prepend(yyvsp[0].list, yyvsp[-2].pattern); }
break;
case 11:
#line 86 "rdql_parser.y"
{ yyval.list = g_slist_prepend(yyvsp[0].list, yyvsp[-1].pattern); }
break;
case 12:
#line 88 "rdql_parser.y"
{ yyval.list = g_slist_alloc();
		    yyval.list->data = yyvsp[0].pattern; }
break;
case 13:
#line 93 "rdql_parser.y"
{ yyval.pattern = new_pattern(yyvsp[-5].part, yyvsp[-3].part, yyvsp[-1].part, NULL); }
break;
case 14:
#line 95 "rdql_parser.y"
{ yyval.pattern = new_pattern(yyvsp[-3].part, yyvsp[-2].part, yyvsp[-1].part, NULL); }
break;
case 15:
#line 97 "rdql_parser.y"
{ yyval.pattern = new_pattern(yyvsp[-7].part, yyvsp[-5].part, yyvsp[-3].part, yyvsp[-1].part); }
break;
case 16:
#line 99 "rdql_parser.y"
{ yyval.pattern = new_pattern(yyvsp[-4].part, yyvsp[-3].part, yyvsp[-2].part, yyvsp[-1].part); }
break;
case 17:
#line 103 "rdql_parser.y"
{ yyval.part = new_part(URI, yyvsp[0].str); }
break;
case 18:
#line 105 "rdql_parser.y"
{ yyval.part = new_part(LITERAL, yyvsp[0].str); }
break;
case 19:
#line 107 "rdql_parser.y"
{ yyval.part = new_part(VARIABLE, yyvsp[0].str); }
break;
case 20:
#line 109 "rdql_parser.y"
{ char *canon = g_strdup_printf("%d", atoi(yyvsp[0].str));
		    yyval.part = new_part(INTEGER, canon); }
break;
case 21:
#line 114 "rdql_parser.y"
{ yyval.list = yyvsp[0].list; }
break;
case 22:
#line 116 "rdql_parser.y"
{ yyval.list = NULL; }
break;
case 23:
#line 120 "rdql_parser.y"
{ yyval.list = g_slist_prepend(yyvsp[0].list, new_prefix(yyvsp[-4].str, yyvsp[-2].str)); }
break;
case 24:
#line 122 "rdql_parser.y"
{ yyval.list = g_slist_prepend(yyvsp[0].list, new_prefix(yyvsp[-3].str, yyvsp[-1].str)); }
break;
case 25:
#line 124 "rdql_parser.y"
{ yyval.list = g_slist_alloc();
		    yyval.list->data = new_prefix(yyvsp[-2].str, yyvsp[0].str); }
break;
case 26:
#line 129 "rdql_parser.y"
{ yyval.list = g_slist_prepend(yyvsp[0].list, yyvsp[-1].constraint); }
break;
case 27:
#line 131 "rdql_parser.y"
{ yyval.list = NULL; }
break;
case 28:
#line 135 "rdql_parser.y"
{ yyval.constraint = new_constraint(yyvsp[-2].part, yyvsp[-1].op, yyvsp[0].part); }
break;
case 29:
#line 137 "rdql_parser.y"
{ yyval.constraint = new_constraint(new_part(VARIABLE, yyvsp[-2].str),
						   EQ_RE,
						   new_part(REGEX, yyvsp[0].str)); }
break;
case 30:
#line 143 "rdql_parser.y"
{ yyval.op = EQ_S; }
break;
case 31:
#line 145 "rdql_parser.y"
{ yyval.op = NE_S; }
break;
case 32:
#line 147 "rdql_parser.y"
{ yyval.op = GT_S; }
break;
case 33:
#line 149 "rdql_parser.y"
{ yyval.op = LT_S; }
break;
case 34:
#line 151 "rdql_parser.y"
{ yyval.op = EQ_N; }
break;
case 35:
#line 153 "rdql_parser.y"
{ yyval.op = NE_N; }
break;
case 36:
#line 155 "rdql_parser.y"
{ yyval.op = GT_N; }
break;
case 37:
#line 157 "rdql_parser.y"
{ yyval.op = LT_N; }
break;
case 38:
#line 159 "rdql_parser.y"
{ yyval.op = LIKE; }
break;
case 39:
#line 161 "rdql_parser.y"
{ yyval.op = EQ_RE; }
break;
case 40:
#line 164 "rdql_parser.y"
{ yyval.integer = atoi(yyvsp[0].str); }
break;
case 41:
#line 166 "rdql_parser.y"
{ yyval.integer = 0; }
break;
case 42:
#line 170 "rdql_parser.y"
{ yyval.integer = atoi(yyvsp[0].str); }
break;
case 43:
#line 172 "rdql_parser.y"
{ yyval.integer = 0; }
break;
#line 663 "rdql_parser.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
