#ifndef YYERRCODE
#define YYERRCODE 256
#endif

#define OPEN_PAR 257
#define CLOSE_PAR 258
#define COMMA 259
#define SELECT 260
#define FROM 261
#define WHERE 262
#define USING 263
#define FOR 264
#define AND 265
#define LIMIT 266
#define OFFSET 267
#define URI 268
#define LITERAL 269
#define VARIABLE 270
#define SYMBOL 271
#define INTEGER 272
#define REGEX 273
#define EQ_S 274
#define NE_S 275
#define GT_S 276
#define LT_S 277
#define EQ_N 278
#define NE_N 279
#define GT_N 280
#define LT_N 281
#define LIKE 282
#define EQ_RE 283
#define EOQ 284
typedef union {
   char         *str;
   pattern_t    *pattern;
   constraint_t *constraint;
   part_t       *part;
   int		 op;
   int		 integer;
   GSList       *list;
} YYSTYPE;
extern YYSTYPE yylval;
